;Source code for Opera Proxy Switcher program by G.Sandler (http://creator-lab.ucoz.ru)
;Version 1.1

#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=Resources\Icon.ico
#AutoIt3Wrapper_outfile=Opera_Proxy_Switcher.exe
#AutoIt3Wrapper_Compression=4
#AutoIt3Wrapper_UseUpx=n
#AutoIt3Wrapper_Res_Comment=Proxy Switcher for Opera.
#AutoIt3Wrapper_Res_Description=Managment program for proxy list in Opera Browser.
#AutoIt3Wrapper_Res_Fileversion=1.1
#AutoIt3Wrapper_Res_LegalCopyright=http://creator-lab.ucoz.ru
#AutoIt3Wrapper_Res_Language=1049
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
;

#NoTrayIcon
#include <GUIConstantsEx.au3>
#include <ButtonConstants.au3>
#include <EditConstants.au3>
#include <ComboConstants.au3>
#include <WindowsConstants.au3>
#include <GUIListView.au3>
#include <GUIIPAddress.au3>
#include ".\Resources\Opera_Library.au3"
#include ".\Resources\BlockInputEx.au3"
;

Global $AppName = "Opera Proxy Switcher"

_CheckAppInstance("OpProxySwitcher", 0, $AppName)

FileChangeDir(@ScriptDir)

;Global Variables and Options
Global Const $WM_LBUTTONDOWN 	= 0x0201

Global $ConfigFile 			= StringTrimRight(@ScriptFullPath, 3) & "ini"
Global $ReadOperaDir 		= IniRead($ConfigFile, "Main Prefs", "Opera Dir", "")
Global $BlockInputOnApply 	= IniRead($ConfigFile, "Main Prefs", "Block Input When Apply", 1)
Global $AddEnableItems 		= IniRead($ConfigFile, "Main Prefs", "Add Enable Items to menu", 1)

Global $OperaDir			= _OperaGetDirChck($ReadOperaDir)
Global $OperaProfileDir		= _OperaGetProfileDir($OperaDir)
Global $OphWnd 				= _OperaGetTitleEx($OperaDir, 1)
Global $MenuFile 			= _OperaGetConfigFile("Menu", $OperaDir)
Global $KeyBoardFile 		= _OperaGetConfigFile("Keyboard", $OperaDir)
Global $Opera6 				= $OperaProfileDir & "\" & __GetOperaPrefsFileName($OperaDir)

;Proxy Switcher Dialog
WinSetState($OphWnd, "", @SW_DISABLE)

Global $GUI_WIDTH = 460
Global $GUI_HEIGHT = 410

$AppWindow_Style = 0
If Not BitAND(WinGetState($OphWnd), 2) Then $AppWindow_Style = $WS_EX_APPWINDOW

$Proxy_GUI = GUICreate($AppName, $GUI_WIDTH, $GUI_HEIGHT, -1, -1, _
	BitOr($GUI_SS_DEFAULT_GUI, $WS_SIZEBOX+$WS_BORDER), $WS_EX_TOOLWINDOW+$WS_EX_CLIENTEDGE+$AppWindow_Style, $OphWnd)

GUIRegisterMsg($WM_GETMINMAXINFO, "WM_GETMINMAXINFO")
GUIRegisterMsg($WM_NOTIFY, "WM_NOTIFY")
GUIRegisterMsg($WM_LBUTTONDOWN, "DRAG_COMMAND")

$Load_From_File_Button = GUICtrlCreateButton("  ...", 20, 10, 120, 20)
$Save_To_File_Button = GUICtrlCreateButton("   ...", 260, 10, 160, 20)

$AddItem_Button = GUICtrlCreateButton(" ", 20, 60, 120, 20)
$EditItem_Button = GUICtrlCreateButton(" ", 160, 60, 120, 20)
$DelItem_Button = GUICtrlCreateButton(" ", 300, 60, 120, 20)

$Proxy_ListView = GUICtrlCreateListView("|: |", 20, 90, 400, 240, _
	$LVS_NOSORTHEADER+$LVS_SHOWSELALWAYS, $LVS_EX_GRIDLINES+$LVS_EX_FULLROWSELECT+$LVS_EX_TRACKSELECT+$WS_EX_CLIENTEDGE)
SetProxyList($MenuFile, "Proxy Switcher Menu")

$hProxy_ListView = GUICtrlGetHandle($Proxy_ListView)

$MoveUp_Button = GUICtrlCreateButton("", 425, ($GUI_HEIGHT/2) - 30, 28, 32, $BS_ICON)
GUICtrlSetImage(-1, "netcfgx.dll", 0)
GUICtrlSetTip(-1, "   ")

$MoveDown_Button = GUICtrlCreateButton("", 425, ($GUI_HEIGHT/2) + 30, 28, 32, $BS_ICON)
GUICtrlSetImage(-1, "netcfgx.dll", -2)
GUICtrlSetTip(-1, "   ")

$AddEnableItems_CB = GUICtrlCreateCheckbox("  ./ ", 20, 375)
If $AddEnableItems = 1 Then GUICtrlSetState(-1, 1)

$OK_Button = GUICtrlCreateButton("", 20, 340, 70, 20)
$Cancel_Button = GUICtrlCreateButton("", 100, 340, 70, 20)

_GUICtrlListViewSetFullColWidth($Proxy_GUI, $Proxy_ListView)

GUISetState(@SW_SHOW, $Proxy_GUI)
WinActivate($OphWnd)

While 1
	Switch GUIGetMsg()
		Case $GUI_EVENT_CLOSE, $Cancel_Button
			Quit(0)
		Case $GUI_EVENT_RESIZED
			_GUICtrlListViewSetFullColWidth($Proxy_GUI, $Proxy_ListView)
		Case $Load_From_File_Button
			Load_From_File_Proc()
			WinActivate($OphWnd)
		Case $Save_To_File_Button
			Local $Get_Items_Count = _GUICtrlListView_GetItemCount($Proxy_ListView)
			If $Get_Items_Count <= 0 Then ContinueLoop
			
			Local $Proxy_List_File = FileSaveDialog(" ...", "", _
				"  (*.txt)|  (*.*)", 18, "Proxy_List.txt", $Proxy_GUI)
			
			If Not @error Then
				If StringRight($Proxy_List_File, 4) <> ".txt" Then $Proxy_List_File &= ".txt"
				WriteProxyList_To_File($Proxy_List_File)
			EndIf
			
			WinActivate($OphWnd)
		Case $AddItem_Button
			Local $Selected_Index = _GUICtrlListView_GetSelectedIndices($Proxy_ListView)
			If $Selected_Index = "" Then $Selected_Index = _GUICtrlListView_GetItemCount($Proxy_ListView)-1
			$Selected_Index = Number($Selected_Index)
			
			If $Selected_Index >= 0 Then $Selected_Index += 1
			
			Edit_Item_Dialog("  -  ", "", $Proxy_GUI, 0, $Selected_Index)
		Case $EditItem_Button
			Local $Selected_Index = _GUICtrlListView_GetSelectedIndices($Proxy_ListView)
			Local $Selected_Text_Arr = _GUICtrlListView_GetItemTextArray($Proxy_ListView)
			If $Selected_Index = "" Then ContinueLoop
			
			$sName = $Selected_Text_Arr[1]
			$sIPAddress = $Selected_Text_Arr[2]
			$sProtocol = $Selected_Text_Arr[3]
			
			Edit_Item_Dialog("  ", _
				"", $Proxy_GUI, 0, -1, Number($Selected_Index), $sName, $sIPAddress, $sProtocol)
		Case $DelItem_Button
			_GUICtrlListView_DeleteItemsSelected($hProxy_ListView)
		Case $MoveUp_Button
			_GUICtrlListViewUpDownItems($Proxy_GUI, $Proxy_ListView, -1)
			ControlFocus($Proxy_GUI, "", $Proxy_ListView)
		Case $MoveDown_Button
			_GUICtrlListViewUpDownItems($Proxy_GUI, $Proxy_ListView, 1)
			ControlFocus($Proxy_GUI, "", $Proxy_ListView)
		Case $OK_Button
			If Not FileExists($MenuFile) Then
				Msgbox(16, $AppName & " - !", _
					"   ,       Opera." & @LF & _
					"         < >", 0, $Proxy_GUI)
				
				ContinueLoop
			EndIf
			
			WriteProxyList_To_Menu($MenuFile, "Proxy Switcher Menu")
			$AddEnableItems = Number(BitAND(GUICtrlRead($AddEnableItems_CB), $GUI_CHECKED))
			IniWrite($ConfigFile, "Main Prefs", "Add Enable Items to menu", $AddEnableItems)
			Quit(1)
	EndSwitch
WEnd

Func Load_From_File_Proc()
	Local $Proxy_File, $ReadFile, $FirstLine, $sProtocol, $Selected_Index
	
	While 1
		$Proxy_File = FileOpenDialog("    ", "", "  (*.*)", 3, "", $Proxy_GUI)
		If @error Then ExitLoop
		
		$ReadFile = StringStripCR(StringStripWS(FileRead($Proxy_File), 3))
		
		If $ReadFile = "" Then
			MsgBox(48, "!", "  .", 0, $Proxy_GUI)
			ContinueLoop
		EndIf
		
		_StringToIPArray($ReadFile)
		
		If @error Then
			Msgbox(48, "!", "     ." & @LF & _
				"   IP ,     .", 0, $Proxy_GUI)
			ContinueLoop
		EndIf
		
		$sProtocol = Edit_Item_Dialog("  [  /     ]", "", $Proxy_GUI, 1)
		
		If $sProtocol <> "" Then
			$Selected_Index = _GUICtrlListView_GetSelectedIndices($Proxy_ListView)
			
			If $Selected_Index = "" Then $Selected_Index = _GUICtrlListView_GetItemCount($Proxy_ListView)-1
			If $Selected_Index >= 0 Then $Selected_Index += 1
			$Selected_Index = Number($Selected_Index)
			
			Add_List_From_File($Proxy_File, $sProtocol, $Selected_Index)
		EndIf
		
		ExitLoop
	WEnd
EndFunc

Func Add_List_From_File($sFile, $sProtcl, $iIndex=-1)
	Local $ReadFileListArr = StringSplit(StringStripCR(FileRead($sFile)), @LF)
	Local $SplitLine, $sName, $sIPAddress, $sProt = $sProtcl, $LV_Data = ""
	
	For $i = 1 To UBound($ReadFileListArr)-1
		If $ReadFileListArr[$i] = "" Then ContinueLoop
		
		$LV_Data = ""
		
		If StringInStr($ReadFileListArr[$i], "|") Then
			$SplitLine = StringSplit($ReadFileListArr[$i], "|")
			$sIPAddress = $SplitLine[1]
			$sName = $sIPAddress
			$sProt = $sProtcl
			
			If Not _IsValidIP($sIPAddress, ":") Then ContinueLoop
			
			If $SplitLine[0] > 1 And $SplitLine[2] <> "" Then $sName = $SplitLine[2]
			If $SplitLine[0] > 2 And $SplitLine[3] <> "" Then $sProt = $SplitLine[3]
			
			$LV_Data = $sName & "|" & $sIPAddress & "|" & $sProt
		ElseIf StringLeft($ReadFileListArr[$i], 3) = "---" Then
			$LV_Data = "----------Sep|----------|----------"
		ElseIf _IsValidIP($ReadFileListArr[$i], ":") Then
			$sProt = $sProtcl
			If $sProtcl = "" Then $sProt = "HTTP"
			$LV_Data = $ReadFileListArr[$i] & "|" & $ReadFileListArr[$i] & "|" & $sProt
		EndIf
		
		If $LV_Data <> "" Then
			_GUICtrlListView_InsertItem($Proxy_ListView, "", $iIndex)
			_GUICtrlListView_SetItemText($Proxy_ListView, $iIndex, $LV_Data, -1)
		EndIf
	Next
EndFunc

Func Edit_Item_Dialog($sTitle, $sButtText, $hWnd, $OnlyProtcl=0, $Indx=-1, $IsEdit=-1, $sName="", $sIPAddress="", $sDefProtcl="")
	Local $IsSep = 0
	
	If StringLeft($sName, 3) = "---" Then
		$sName = ""
		$sIPAddress = ""
		$sDefProtcl = ""
		$IsSep = 1
	EndIf
	
	Local $sProtocol = "", $sPort = "", $RetValue = ""
	If $sDefProtcl = "" Then $sDefProtcl = "HTTP"
	
	GUISetState(@SW_DISABLE, $hWnd)
	Local $Edit_Item_Gui = GUICreate($sTitle, 490, 145, -1, -1, -1, $WS_EX_TOOLWINDOW, $hWnd)
	
	GUICtrlCreateGroup(" ", 10, 10, 470, 90)
	
	GUICtrlCreateLabel("", 20, 40)
	Local $Name_Input = GUICtrlCreateInput($sName, 20, 60, 120, 22)
	
	GUICtrlCreateLabel("IP  [*]", 160, 40)
	Local $hIP_Address = _GUICtrlIpAddress_Create($Edit_Item_Gui, 160, 60, 120, 22)
	
	GUICtrlCreateLabel("", 300, 40)
	Local $Port_Input = GUICtrlCreateInput("", 300, 60, 70, 22, $ES_NUMBER)
	
	If $sIPAddress <> "" Then
		$sPort = StringTrimLeft($sIPAddress, StringInStr($sIPAddress, ":"))
		$sIPAddress = StringLeft($sIPAddress, StringInStr($sIPAddress, ":")-1)
		
		_GUICtrlIpAddress_Set($hIP_Address, $sIPAddress)
		GUICtrlSetData($Port_Input, $sPort)
	EndIf
	
	GUICtrlCreateLabel("", 390, 40)
	Local $Protocol_Combo = GUICtrlCreateCombo("", 390, 60, 70, 22, $CBS_DROPDOWNLIST)
	GUICtrlSetData(-1, "HTTP|HTTPS|FTP", $sDefProtcl)
	
	Local $Seperator_CB = GUICtrlCreateCheckbox("", 220, 110)
	
	Local $Edit_OK_Button = GUICtrlCreateButton($sButtText, 20, 110, 70, 20)
	Local $Edit_Cancel_Button = GUICtrlCreateButton("", 100, 110, 70, 20)
	
	If $OnlyProtcl Then
		GUICtrlSetState($Name_Input, 128)
		GUICtrlSetState($Port_Input, 128)
		GUICtrlSetState($Seperator_CB, 128)
		ControlDisable($Proxy_GUI, "", $hIP_Address)
	EndIf
	
	If $IsSep Then
		GUICtrlSetState($Seperator_CB, 1)
		
		For $i = $Name_Input-1 To $Protocol_Combo
			GUICtrlSetState($i, 128)
		Next
		
		ControlDisable($Proxy_GUI, "", $hIP_Address)
	EndIf
	
	GUISetState(@SW_SHOW, $Edit_Item_Gui)
	
	While 1
		Switch GUIGetMsg()
			Case $GUI_EVENT_CLOSE, $Edit_Cancel_Button
				If $OnlyProtcl Then $RetValue = $sDefProtcl
				ExitLoop
			Case $Seperator_CB
				Local $iState = 64
				
				If GUICtrlRead($Seperator_CB) = 1 Then
					$iState = 128
					ControlDisable($Proxy_GUI, "", $hIP_Address)
				Else
					ControlEnable($Proxy_GUI, "", $hIP_Address)
				EndIf
				
				For $i = $Name_Input-1 To $Protocol_Combo
					GUICtrlSetState($i, $iState)
				Next
			Case $Edit_OK_Button
				$sName = StringReplace(GUICtrlRead($Name_Input), "|", "_")
				$sIPAddress = _GUICtrlIpAddress_Get($hIP_Address)
				$sPort = GUICtrlRead($Port_Input)
				$sProtocol = GUICtrlRead($Protocol_Combo)
				
				Local $IsSeperator = GUICtrlRead($Seperator_CB) = 1
				
				If $OnlyProtcl = 0 Then
					If Not $IsSeperator Then
						If _GUICtrlIpAddress_IsBlank($hIP_Address) Then
							MsgBox(48, "!", "  IP .", 0, $Edit_Item_Gui)
							_GUICtrlIpAddress_SetFocus($hIP_Address, 0)
							ContinueLoop
						EndIf
						
						If $sPort = "" Then $sPort = "8080"
						$sIPAddress &= ":" & $sPort
						
						If $sName = "" Then $sName = $sIPAddress
					Else
						$sName = "----------Sep"
						$sIPAddress = "----------"
						$sProtocol = "----------"
					EndIf
					
					If $IsEdit <> -1 Then
						_GUICtrlListView_SetItemText($Proxy_ListView, $IsEdit, $sName, 0)
						_GUICtrlListView_SetItemText($Proxy_ListView, $IsEdit, $sIPAddress, 1)
						_GUICtrlListView_SetItemText($Proxy_ListView, $IsEdit, $sProtocol, 2)
					Else
						$Indx = _GUICtrlListView_InsertItem($Proxy_ListView, "", $Indx)
						_GUICtrlListView_SetItemText($Proxy_ListView, $Indx, $sName & "|" & $sIPAddress & "|" & $sProtocol, -1)
					EndIf
				Else
					$RetValue = $sProtocol
				EndIf
				
				ExitLoop
		EndSwitch
	WEnd
	
	GUISetState(@SW_ENABLE, $hWnd)
	GUIDelete($Edit_Item_Gui)
	GUISwitch($hWnd)
	
	Return $RetValue
EndFunc

Func SetProxyList($MenuFile, $SectName)
	Local $ProxyListArr = IniReadSection($MenuFile, $SectName)
	If @error Then Return SetError(1, 0, "")
	
	Local $sProxy_Name, $sProxy_Address, $sProxy_Protcl, $iIndx
	
	For $i = 1 To $ProxyListArr[0][0]
		If StringInStr($ProxyListArr[$i][0], "-----EndSep") Or StringRegExp($ProxyListArr[$i][0], "-+[0-9]") Then ExitLoop
		If StringInStr($ProxyListArr[$i][0], "-----Sep") Then
			$iIndx = _GUICtrlListView_InsertItem($Proxy_ListView, "", -1)
			_GUICtrlListView_SetItemText($Proxy_ListView, $iIndx, "----------Sep|----------|----------", -1)
		Else
			$sProxy_Name = StringRegExpReplace($ProxyListArr[$i][0], '(?i)Item,?|"', '')
			$sProxy_Address = StringRegExpReplace($ProxyListArr[$i][1], '(?i)Set preference, "Proxy\|.*?=(.*?)"', '\1')
			$sProxy_Protcl = StringRegExpReplace($ProxyListArr[$i][1], '(?i)Set preference, "Proxy\|(.*?) server.*?$', '\1')
			
			$sProxy_Name = _Utf8ToAnsi(StringStripWS($sProxy_Name, 3))
			$sProxy_Address = StringStripWS($sProxy_Address, 3)
			$sProxy_Protcl = StringStripWS($sProxy_Protcl, 3)
			
			$iIndx = _GUICtrlListView_InsertItem($Proxy_ListView, "", -1)
			_GUICtrlListView_SetItemText($Proxy_ListView, $iIndx, $sProxy_Name & "|" & $sProxy_Address & "|" & $sProxy_Protcl, -1)
		EndIf
	Next
EndFunc

Func WriteProxyList_To_File($sFile)
	Local $Get_Items_Count = _GUICtrlListView_GetItemCount($Proxy_ListView)
	If $Get_Items_Count <= 0 Then Return
	
	Local $Proxy_Name, $Proxy_Address, $Proxy_Protc
	Local $CRLF = @CRLF
	
	Local $hFile = FileOpen($sFile, 2)
	
	For $i = 0 To $Get_Items_Count-1
		$Proxy_Name = _GUICtrlListView_GetItemText($Proxy_ListView, $i, 0)
		$Proxy_Address = _GUICtrlListView_GetItemText($Proxy_ListView, $i, 1)
		$Proxy_Protc = _GUICtrlListView_GetItemText($Proxy_ListView, $i, 2)
		
		If $i = $Get_Items_Count-1 Then $CRLF = ''
		
		If StringLeft($Proxy_Name, 3) = '---' Then
			FileWrite($hFile, '----------Sep' & $CRLF)
		ElseIf $Proxy_Name <> '' Then
			FileWrite($hFile, $Proxy_Address & '|' & $Proxy_Name & '|' & $Proxy_Protc & $CRLF)
		EndIf
	Next
	
	FileClose($hFile)
EndFunc

Func WriteProxyList_To_Menu($MenuFile, $SectName)
	Local $Get_Items_Count = _GUICtrlListView_GetItemCount($Proxy_ListView)
	
	Local $Proxy_Name, $Proxy_Address, $Proxy_Protc
	Local $iSep_Counter = 0
	
	IniDelete($MenuFile, $SectName)
	
	For $i = 0 To $Get_Items_Count-1
		$Proxy_Name = _GUICtrlListView_GetItemText($Proxy_ListView, $i, 0)
		$Proxy_Address = _GUICtrlListView_GetItemText($Proxy_ListView, $i, 1)
		$Proxy_Protc = _GUICtrlListView_GetItemText($Proxy_ListView, $i, 2)
		
		If StringLeft($Proxy_Name, 3) = '---' Then
			If $i < $Get_Items_Count-1 Then
				IniWrite($MenuFile, $SectName, '----------Sep' & $iSep_Counter, '')
				$iSep_Counter += 1
			EndIf
		ElseIf $Proxy_Name <> '' Then
			IniWrite($MenuFile, $SectName, 'Item, "' & StringToUTF($Proxy_Name) & '"', _
				'Set preference, "Proxy|' & $Proxy_Protc & ' server=' & $Proxy_Address & '"')
		EndIf
	Next
	
	If GUICtrlRead($AddEnableItems_CB) = 1 Then
		Local $EnableItems_Key_Data = '----------EndSep=' & @LF & _
			'Item, "  ..."=Show preferences, 23 & Show proxy servers' & @LF & _
			'Item, "  "=Enable proxy servers | Disable proxy servers' & @LF & _
			'Item, " HTTP 1.1  "'
		
		Local $EnableItems_Val_Data = 'Set preference, "Proxy|Enable HTTP 1.1 for proxy=1" | ' & _
			'Set preference, "Proxy|Enable HTTP 1.1 for proxy=0"' & @LF & _
			'----------EndSep1=' & @LF & _
			'Item, " HTTP proxy"=Set preference, "Proxy|Use HTTP=1" | Set preference, "Proxy|Use HTTP=0"' & @LF & _
			'Item, " HTTPS proxy"=Set preference, "Proxy|Use HTTPS=1" | Set preference, "Proxy|Use HTTPS=0"' & @LF & _
			'Item, " FTP proxy"=Set preference, "Proxy|Use FTP=1" | Set preference, "Proxy|Use FTP=0"'
		
		IniWrite($MenuFile, $SectName, StringToUTF($EnableItems_Key_Data), StringToUTF($EnableItems_Val_Data))
	EndIf
EndFunc

Func ApplyMenu_Proc($KeyBoardFile)
	If $BlockInputOnApply = 1 Then
		_BlockInputEx(1, "{MMOVE}|{CTRL}|{ALT}|a")
		Sleep(10)
	EndIf
	
	WinActivate($OphWnd)
	WinWaitActive($OphWnd, "", 5)
	
	If @KBLayout = 0419 Then
		Send("^!")
	Else
		Send("^!a")
	EndIf
	
	If $BlockInputOnApply = 1 Then
		Sleep(1000)
		_BlockInputEx(0)
	EndIf
	
	Local $KeyBoardFileName = StringRegExpReplace($KeyBoardFile, "^.*\\", "")
	Local $KeyStr = "Show preferences, 23 & Rename menu setup & Click default button"
	
	If IniRead($KeyBoardFile, "Application", "a ctrl alt", "") <> $KeyStr Or _
		IniRead($KeyBoardFile, "Application", " ctrl alt", "") <> $KeyStr Then
		IniWrite($KeyBoardFile, "Application", "a ctrl alt", $KeyStr)
		IniWrite($KeyBoardFile, "Application", " ctrl alt", $KeyStr)
		
		MsgBox(262144+48, " !", _
			"       <" & $KeyBoardFileName & ">." & @LF & _
			"  Opera.", 0, $OphWnd)
	EndIf
EndFunc

Func _OperaGetTitleEx($sOperaDir=@ScriptDir, $iRet=-1)
	Local $sOpTitle = ""
	If FileExists($sOperaDir & "\opera.exe") Then $sOpTitle = _WinGetTitleEx($sOperaDir & "\opera.exe")
	
	If Not WinExists($sOpTitle) Or $sOpTitle = "" Then
		$sOpTitle = WinGetTitle("[REGEXPTITLE:(.*?)- Opera; CLASS:OpWindow]")
		$sOpTitle = StringLeft($sOpTitle, StringInStr($sOpTitle, "-", 0, -1))
		If StringRight($sOpTitle, 1) = "-" Then $sOpTitle = StringStripWS(StringTrimRight($sOpTitle, 1), 3)
		If Not WinExists($sOpTitle) Or $sOpTitle = "" Then $sOpTitle = "Opera"
	EndIf
	
	Local $sOphWnd = WinGetHandle($sOpTitle)
	
	Switch $iRet
		Case -1
			Local $aRetArr[2] = [$sOpTitle, $sOphWnd]
			Return $aRetArr
		Case 0
			Return $sOpTitle
		Case 1
			Return $sOphWnd
	EndSwitch
	
	Return SetError(1, 0, "")
EndFunc

Func _OperaGetDirChck($CheckOpDir="")
	If FileExists($CheckOpDir & "\Opera.exe") Then Return $CheckOpDir
	
	Return _OperaGetDir()
EndFunc

Func _GUICtrlListViewSetFullColWidth($hWnd, $hLV)
	Local $Columns_Count = _GUICtrlListView_GetColumnCount($hLV)
	Local $LV_Width = ControlGetPos($hWnd, "", $hLV)
	If @error Then Return
	
	Local $iLV_Width = ($LV_Width[2]-10) / $Columns_Count
	
	For $i = 0 To $Columns_Count
		GUICtrlSendMsg($hLV, $LVM_SETCOLUMNWIDTH, $i, $iLV_Width)
	Next
EndFunc

Func _GUICtrlListViewUpDownItems($hWnd, $ListView, $UpDown=1)
	Local $IndexArr = _GUICtrlListView_GetSelectedIndices($Listview, 1)
	If Not IsArray($IndexArr) Then Return SetError(1, 0, "")
	If $UpDown <> 1 And $UpDown <> -1 Then Return SetError(2, 0, -1)
	Local $ItemsCount = ControlListView($hWnd, "", $ListView, "GetItemCount")
	Local $ColumnCount = ControlListView($hWnd, "", $ListView, "GetSubItemCount")
	Local $Ubound, $iNum, $Step, $CurrentIndex, $UpDowntIndex, $CurrItemText, $UpDowntItemText
	
	If ($UpDown = -1 And $IndexArr[1] = 0) Or _
		($UpDown = 1 And $IndexArr[UBound($IndexArr)-1] = $ItemsCount-1) Then Return SetError(3, 0, "")
	
	ControlListView($hWnd, "", $ListView, "SelectClear")
	
	$Ubound = UBound($IndexArr)-1
	$iNum = 1
	$Step = 1
	
	If $UpDown = 1 Then
		$Ubound = 1
		$iNum = UBound($IndexArr)-1
		$Step = -1
	EndIf
	
	For $i = $iNum To $Ubound Step $Step
		$CurrentIndex = $IndexArr[$i]
		$UpDowntIndex = $IndexArr[$i]+1
		If $UpDown = -1 Then $UpDowntIndex = $IndexArr[$i]-1
		
		ControlListView($hWnd, "", $ListView, "Select", $UpDowntIndex)
		
		For $j = 0 To $ColumnCount
			$CurrItemText = _GUICtrlListView_GetItemText($ListView, $CurrentIndex, $j)
			$UpDowntItemText = _GUICtrlListView_GetItemText($ListView, $UpDowntIndex, $j)
			_GUICtrlListView_SetItemText($ListView, $UpDowntIndex, $CurrItemText, $j)
			_GUICtrlListView_SetItemText($ListView, $CurrentIndex, $UpDowntItemText, $j)
		Next
	Next
EndFunc

Func _WinGetTitleEx($ExTitle)
	If IsHWnd($ExTitle) Then Return WinGetTitle($ExTitle)
	Local $OldOpt = Opt("WinTitleMatchMode", 2)
	Local $RetTitle = _PathIsProcess($ExTitle)
	If $RetTitle Then $RetTitle = _WinGetTitleByPID($RetTitle)
	If Not $RetTitle Then $RetTitle = WinGetTitle($ExTitle)
	
	If Not WinExists($RetTitle) Or Not $RetTitle Then
		Opt("WinTitleMatchMode", 4)
		$RetTitle = WinGetTitle($ExTitle)
		If Not $RetTitle Then $RetTitle = WinGetTitle("[REGEXP:(?i)(.*)" & $ExTitle & "(.*)]")
	EndIf
	
	Opt("WinTitleMatchMode", $OldOpt)
	Return $RetTitle
EndFunc

Func _WinGetTitleByPID($iPID, $nArray = 1)
    If IsString($iPID) Then $iPID = ProcessExists($iPID)
    Local $aWList = WinList(), $sHold
    For $iCC = 1 To $aWList[0][0]
        If WinGetProcess($aWList[$iCC][1]) = $iPID And _
            BitAND(WinGetState($aWList[$iCC][1]), 2) Then
            If $nArray Then Return $aWList[$iCC][0]
            $sHold &= $aWList[$iCC][0] & Chr(1)
        EndIf
    Next
    If $sHold Then Return StringSplit(StringTrimRight($sHold, 1), Chr(1))
    Return SetError(1, 0, 0)
EndFunc

Func _PathIsProcess($sPath)
	If Not FileExists($sPath) Then Return SetError(1, 0, False)
	Local $ObjWMIService, $ProcItems, $Extended = 0
	Local $sPathName = StringRegExpReplace($sPath, "^.*\\", "")
	If Not ProcessExists($sPathName) Then Return SetError(2, 0, False)
	Local $ProcessList = ProcessList($sPathName)
	$Extended = UBound($ProcessList)-1
	
	$OEvent = ObjEvent("AutoIt.Error", "ExecQueryHandler")
	$ObjWMIService = ObjGet("winmgmts:\\" & @ComputerName & "\root\CIMV2")
	If IsObj($ObjWMIService) Then
		For $i = 1 To $Extended
			$ProcItems = $ObjWMIService.ExecQuery("SELECT * FROM Win32_Process WHERE ProcessId = " & _
				$ProcessList[$i][1], "WQL", 0x30)
			If IsObj($ProcItems) Then
				For $ObjItem In $ProcItems
					If $ObjItem.ExecutablePath = $sPath Then Return SetExtended($Extended, $ObjItem.ProcessID)
				Next
			EndIf
		Next
	EndIf
	Return SetExtended($Extended, False)
EndFunc

Func _IsValidIP($sString, $sDelim="")
	If Not StringInStr($sString, ".") Then Return 0
	If $sDelim <> "" Then $sString = StringLeft($sString, StringInStr($sString, $sDelim)-1)
	If StringLen($sString) > 15 Then Return 0
	
	Local $Dot_Split = StringSplit($sString, ".")
	Local $iUbound = UBound($Dot_Split)-1
	If $iUbound <> 4 Then Return 0
	
	For $i = 1 To $iUbound
		If $Dot_Split[$i] = "" Then Return 0
		If StringRegExp($Dot_Split[$i], '[^0-9]') Or Number($Dot_Split[$i]) > 255 Then Return 0
	Next
	
	If $sDelim <> "" Then Return $sString
    Return 1
EndFunc

Func _StringToIPArray($sString)
	Local $avArray = StringRegExp($sString, '([0-9]+\.[0-9]+\.[0-9]+\.[0-9]+)', 3)
	Local $avRetArr[1], $iUbound
	
	For $i = 0 To UBound($avArray)-1
		If _IsValidIP($avArray[$i]) Then
			$iUbound = UBound($avRetArr)
			ReDim $avRetArr[$iUbound+1]
			$avRetArr[$iUbound] = $avArray[$i]
		EndIf
	Next
	
	If $iUbound = 0 Then Return SetError(1, 0, 0)
	
	$avRetArr[0] = $iUbound
	Return $avRetArr
EndFunc

Func StringToUTF($String)
	Dim $sResult = ""
	$VarUTFArr = StringSplit($String, "")
	If IsArray($VarUTFArr) Then
		For $i = 1 To $VarUTFArr[0]
			$code = Asc($VarUTFArr[$i])
			Select
				Case $code >= 192 And $code <= 239
					$VarUTFArr[$i] = Chr(208) & Chr($code - 48)
				Case $code >= 240 And $code <= 255
					$VarUTFArr[$i] = Chr(209) & Chr($code - 112)
				Case $code = 168
					$VarUTFArr[$i] = Chr(208) & Chr(129)
				Case $code = 184
					$VarUTFArr[$i] = Chr(209) & Chr(145)
				Case Else
					$VarUTFArr[$i] = Chr($code)
			EndSelect
			$sResult &= $VarUTFArr[$i]
		Next
	EndIf
	Return $sResult
EndFunc

Func _Utf8ToAnsi($utf8string)
    Local $len = StringLen($utf8string)
    Local $buf = DllStructCreate("byte[" & $len*2 & "];byte[2]")
    Local $ret = DllCall("Kernel32.dll", "int", "MultiByteToWideChar", _
        "int", 65001, "int", 0, _
        "str", $utf8string, "int", -1, _
        "ptr", DllStructGetPtr($buf), "int", $len*2+2)
    Local $out = DllStructCreate("char[" & $len & "];char")
    $ret = DllCall("kernel32.dll", "int", "WideCharToMultiByte", _
        "int", 0, "int", 0, _
        "ptr", DllStructGetPtr($buf), "int", -1, _
        "ptr", DllStructGetPtr($out), "int", $len+1, _
        "int", 0, "int", 0)
    Return DllStructGetData($out,1)
EndFunc

Func WM_GETMINMAXINFO($hWnd, $Msg, $wParam, $lParam)
	Local $MINGuiX = $GUI_WIDTH + 12
	Local $MINGuiY = $GUI_HEIGHT + 30
	Local $MAXGuiX = 600
	Local $MAXGuiY = 500
	
	Local $MinMaxInfo = DllStructCreate("int;int;int;int;int;int;int;int;int;int", $lParam)
	DllStructSetData($MinMaxInfo, 7, $MINGuiX) ; min X
	DllStructSetData($MinMaxInfo, 8, $MINGuiY) ; min Y
	DllStructSetData($MinMaxInfo, 9, $MAXGuiX) ; max X
	DllStructSetData($MinMaxInfo, 10, $MAXGuiY) ; max Y
	Return $GUI_RUNDEFMSG
EndFunc

Func WM_NOTIFY($hWnd, $MsgID, $wParam, $lParam)
	Local $TagNMHDR = DllStructCreate("int;int;int", $lParam)
	If @error Then Return $GUI_RUNDEFMSG
	Local $iEvent = DllStructGetData($TagNMHDR, 3)
	
	If $wParam = $Proxy_ListView And $iEvent = -3 Then
		If Number(_GUICtrlListView_GetSelectedIndices($Proxy_ListView)) < 0 Then
			ControlClick($Proxy_GUI, "", $AddItem_Button)
		Else
			ControlClick($Proxy_GUI, "", $EditItem_Button)
		EndIf
	EndIf
	
	$TagNMHDR = DllStructCreate("int;int;int;uint;uint;uint;int;int", $lParam)
	If @error Then Return $GUI_RUNDEFMSG
	
	Local Const $LVN_BEGINDRAG = 0xFFFFFF93
	Local $iEvent = DllStructGetData($TagNMHDR, 3)
	If $wParam = $Proxy_ListView And $iEvent = $LVN_BEGINDRAG Then Return 0
	
	Return $GUI_RUNDEFMSG
EndFunc

Func DRAG_COMMAND($HWnd,$command,$wParam,$lParam)
	If BitAND(WinGetState($HWnd), 32) Then Return $GUI_RUNDEFMSG
	DllCall("user32.dll", "long", "SendMessage", "hwnd", $HWnd, "int", $WM_SYSCOMMAND, "int", 0xF009, "int", 0)
EndFunc

Func _CheckAppInstance($OccurenceName=@ScriptName, $iFlag = 0, $sActivateTitle="")
	Local $ERROR_ALREADY_EXISTS = 183
	$OccurenceName = StringReplace($OccurenceName, "\", "") ; to avoid error
	Local $sHandle = DllCall("kernel32.dll", "int", "CreateMutex", "int", 0, "long", 1, "str", $OccurenceName)
	Local $iLastError = DllCall("kernel32.dll", "int", "GetLastError")
	If $iLastError[0] = $ERROR_ALREADY_EXISTS Then
		If $iFlag = 0 Then
			If $sActivateTitle <> "" Then WinActivate($sActivateTitle)
			Exit -1
		EndIf
		Return SetError($iLastError[0], "", 0)
	EndIf
	Return $sHandle[0]
EndFunc

Func Quit($Apply=0)
	WinSetState($OphWnd, "", @SW_ENABLE)
	GUISetState(@SW_HIDE, $Proxy_GUI)
	
	If $Apply Then ApplyMenu_Proc($KeyBoardFile)
	
	IniWrite($ConfigFile, "Main Prefs", "Opera Dir", $OperaDir)
	
	Exit
EndFunc
